<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Izg project: student/linearAlgebra.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Izg project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_df997ef5cbe81af8266600b381d65502.html">student</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">linearAlgebra.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="linearAlgebra_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#pragma once</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="student_2fwd_8h.html">student/fwd.h</a>&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="structVec2.html">   21</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structVec2.html">Vec2</a> {</div><div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="structVec2.html#a9261a5afe6b8369034a4a2157ab6b242">   22</a></span>&#160;  <span class="keywordtype">float</span> <a class="code" href="structVec2.html#a9261a5afe6b8369034a4a2157ab6b242">data</a>[2];  </div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;};</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="structVec3.html">   28</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structVec3.html">Vec3</a> {</div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="structVec3.html#ab4091bcbf544cb1ae91ba8855ddaaa0b">   29</a></span>&#160;  <span class="keywordtype">float</span> <a class="code" href="structVec2.html#a9261a5afe6b8369034a4a2157ab6b242">data</a>[3];  </div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;};</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="structVec4.html">   35</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structVec4.html">Vec4</a> {</div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="structVec4.html#aee1e79a1c063cba1c01227258a5e1d9f">   36</a></span>&#160;  <span class="keywordtype">float</span> <a class="code" href="structVec2.html#a9261a5afe6b8369034a4a2157ab6b242">data</a>[4];  </div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;};</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="structMat4.html">   43</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structMat4.html">Mat4</a> {</div><div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="structMat4.html#a89c6922a5ca3584062e9841090709592">   44</a></span>&#160;  <a class="code" href="structVec4.html">Vec4</a> column[4];  </div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;};</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#ab34a9fd703888343eb0a7e2b27961fb3">zero_Vec2</a>(<a class="code" href="structVec2.html">Vec2</a> *<span class="keyword">const</span> target);</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a5831ca0dbb0d418b2abc78df14dc1e17">zero_Vec3</a>(<a class="code" href="structVec3.html">Vec3</a> *<span class="keyword">const</span> target);</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#ae21bc90966c71e70db9ee62e6d34f58b">zero_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> target);</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a2d4ebe1f775e16099a296626a20e944b">init_Vec2</a>(<a class="code" href="structVec2.html">Vec2</a> *<span class="keyword">const</span> target, <span class="keywordtype">float</span> <span class="keyword">const</span> x, <span class="keywordtype">float</span> <span class="keyword">const</span> y);</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a898abc01a7905b120121d45afaba6635">init_Vec3</a>(<a class="code" href="structVec3.html">Vec3</a> *<span class="keyword">const</span> target, <span class="keywordtype">float</span> <span class="keyword">const</span> x, <span class="keywordtype">float</span> <span class="keyword">const</span> y, <span class="keywordtype">float</span> <span class="keyword">const</span> z);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a68a9da6c0c100b70184cd882ace57195">init_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> target, <span class="keywordtype">float</span> <span class="keyword">const</span> x, <span class="keywordtype">float</span> <span class="keyword">const</span> y, <span class="keywordtype">float</span> <span class="keyword">const</span> z,</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;               <span class="keywordtype">float</span> <span class="keyword">const</span> w);</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a4b41c4aa935f692847c98caf969f4274">copy_Vec2</a>(<a class="code" href="structVec2.html">Vec2</a> *<span class="keyword">const</span> target, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> source);</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a92095b5e7b71fdf9862d93defbd05c48">copy_Vec3</a>(<a class="code" href="structVec3.html">Vec3</a> *<span class="keyword">const</span> target, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> source);</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#ae2b536efaebb3d1c2377ee9ed17a59ee">copy_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> target, <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> source);</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a46906f31d88c1e39620f3dc2bdcc1647">copy_Vec4_To_Vec2</a>(<a class="code" href="structVec2.html">Vec2</a> *<span class="keyword">const</span> target, <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> source);</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a67ce5bc16a11e536343b57c65f92e956">copy_Vec4_To_Vec3</a>(<a class="code" href="structVec3.html">Vec3</a> *<span class="keyword">const</span> target, <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> source);</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a7ada27d45ccfc6522aed3eae2ed8285d">copy_Vec3_To_Vec2</a>(<a class="code" href="structVec2.html">Vec2</a> *<span class="keyword">const</span> target, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> source);</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#aa6574ab0f21fd2161a67abef60544177">copy_Vec3Float_To_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> target, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> part0,</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;                            <span class="keywordtype">float</span> <span class="keyword">const</span> part1);</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#acecead10da9d132574e7f7de5b28158b">copy_Vec2FloatFloat_To_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> target, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> part0,</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;                                 <span class="keywordtype">float</span> <span class="keyword">const</span> part1, <span class="keywordtype">float</span> <span class="keyword">const</span> part2);</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a04beb577fb3eb16b699b38c255d8a1c6">copy_Vec2Vec2_To_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> target, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> part0,</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;                           <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> part1);</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#ab16d533e580c6a3e2a640bdf17bbc9d1">copy_FloatVec2Float_To_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> target, <span class="keywordtype">float</span> <span class="keyword">const</span> part0,</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;                                 <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> part1, <span class="keywordtype">float</span> <span class="keyword">const</span> part2);</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#aa007b2ebb3ea356de37ab0d0fa920df7">copy_FloatFloatVec2_To_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> target, <span class="keywordtype">float</span> <span class="keyword">const</span> part0,</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;                                 <span class="keywordtype">float</span> <span class="keyword">const</span> part1, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> part2);</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#abf949f1e249e3d1c231ee72e65a9696a">copy_FloatVec3_To_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> target, <span class="keywordtype">float</span> <span class="keyword">const</span> part0,</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;                            <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> part1);</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#ac534ff8c157e83446ca974ab14b93a5d">copy_Vec2Float_ToVec3</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> target, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> part0,</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;                           <span class="keywordtype">float</span> <span class="keyword">const</span> part1);</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a7c4638820b8913fe877927aaf4c84491">copy_FloatVec2_ToVec3</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> target, <span class="keywordtype">float</span> <span class="keyword">const</span> part0,</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;                           <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> part1);</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#ab6dcfc6d07f8a2a3d14935cbf3bbfa07">add_Vec2</a>(<a class="code" href="structVec2.html">Vec2</a> *<span class="keyword">const</span> output, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> a, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> b);</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a1e6a2affc4b7825a83ce3237c24dc6ce">add_Vec3</a>(<a class="code" href="structVec3.html">Vec3</a> *<span class="keyword">const</span> output, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> a, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> b);</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a216e370049726fef73d41d74a7fdbb0a">add_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> output, <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> a, <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> b);</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a4c64ae6faf0fd46a33d75789168d7f9e">sub_Vec2</a>(<a class="code" href="structVec2.html">Vec2</a> *<span class="keyword">const</span> output, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> a, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> b);</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#ad4d638794632fe961f6e5113905e34e1">sub_Vec3</a>(<a class="code" href="structVec3.html">Vec3</a> *<span class="keyword">const</span> output, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> a, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> b);</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#aa24f5597fea40cea6a1f928efd5f78f8">sub_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> output, <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> a, <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> b);</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a0b0e854e25bc6e5d1438feca06b090d7">mix_Vec2</a>(<a class="code" href="structVec2.html">Vec2</a> *<span class="keyword">const</span> output, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> a, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> b,</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;              <span class="keywordtype">float</span> <span class="keyword">const</span> t);</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a6d4b5718ff844e740c5263bddecb6a59">mix_Vec3</a>(<a class="code" href="structVec3.html">Vec3</a> *<span class="keyword">const</span> output, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> a, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> b,</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;              <span class="keywordtype">float</span> <span class="keyword">const</span> t);</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a0a2303f1ff51da7b5b5391118c21c082">mix_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> output, <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> a, <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> b,</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;              <span class="keywordtype">float</span> <span class="keyword">const</span> t);</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;<span class="keywordtype">float</span> <a class="code" href="linearAlgebra_8h.html#a84d6cf8f129f96393c19af1cd4da6475">dot_Vec2</a>(<a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> left, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> right);</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;<span class="keywordtype">float</span> <a class="code" href="linearAlgebra_8h.html#a2edd6c868ced671c9680036a35c2a928">dot_Vec3</a>(<a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> left, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> right);</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;<span class="keywordtype">float</span> <a class="code" href="linearAlgebra_8h.html#a41de0162479b762fb9636c4ca2ec67bc">dot_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> left, <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> right);</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#aff57f5f65e1600067a40687ceea23874">multiply_Vec2_Float</a>(<a class="code" href="structVec2.html">Vec2</a> *<span class="keyword">const</span> output, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> left,</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;                         <span class="keywordtype">float</span> <span class="keyword">const</span> constant);</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a700c57a419d937e84616e877039ea500">multiply_Vec3_Float</a>(<a class="code" href="structVec3.html">Vec3</a> *<span class="keyword">const</span> output, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> left,</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;                         <span class="keywordtype">float</span> <span class="keyword">const</span> constant);</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a03f118667e1d4b11494bcb17ea2053cd">multiply_Vec4_Float</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> output, <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> left,</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;                         <span class="keywordtype">float</span> <span class="keyword">const</span> constant);</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;<span class="keywordtype">float</span> <a class="code" href="linearAlgebra_8h.html#a4d63505aa04912e56e7718227477339d">length_Vec2</a>(<a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> vec);</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;<span class="keywordtype">float</span> <a class="code" href="linearAlgebra_8h.html#a39cec24734072d94f327b9ee5c1b3681">length_Vec3</a>(<a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> vec);</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;<span class="keywordtype">float</span> <a class="code" href="linearAlgebra_8h.html#aa91dd68aad82e3c0c6b605f44079b00d">length_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> vec);</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#aef887725c2f4d11256731400b232a1bf">normalize_Vec2</a>(<a class="code" href="structVec2.html">Vec2</a> *<span class="keyword">const</span> output, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> input);</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;</div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a29413d309c1692fac4d63a4fc080903c">normalize_Vec3</a>(<a class="code" href="structVec3.html">Vec3</a> *<span class="keyword">const</span> output, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> input);</div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;</div><div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a8333ef95a3ea4503121bd0f8ec2e5a93">normalize_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> output, <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> input);</div><div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;</div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#ac2909e84e7ff2328f4022195c670f098">multiply_Mat4_Vec4</a>(<a class="code" href="structVec4.html">Vec4</a> *<span class="keyword">const</span> output, <a class="code" href="structMat4.html">Mat4</a> <span class="keyword">const</span> *<span class="keyword">const</span> left,</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;                        <a class="code" href="structVec4.html">Vec4</a> <span class="keyword">const</span> *<span class="keyword">const</span> right);</div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;</div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#ab490710375f17e4c453720b4f3a6de1f">multiply_Mat4_Mat4</a>(<a class="code" href="structMat4.html">Mat4</a> *<span class="keyword">const</span> output, <a class="code" href="structMat4.html">Mat4</a> <span class="keyword">const</span> *<span class="keyword">const</span> left,</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;                        <a class="code" href="structMat4.html">Mat4</a> <span class="keyword">const</span> *<span class="keyword">const</span> right);</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#abc0563608a098756d6628f85c5805bf6">identity_Mat4</a>(<a class="code" href="structMat4.html">Mat4</a> *<span class="keyword">const</span> output);</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;</div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a4ea2f3b452065b47f0068eb9b4cc4ca9">translate_Mat4</a>(<a class="code" href="structMat4.html">Mat4</a> *<span class="keyword">const</span> output, <span class="keywordtype">float</span> <span class="keyword">const</span> tx, <span class="keywordtype">float</span> <span class="keyword">const</span> ty,</div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;                    <span class="keywordtype">float</span> <span class="keyword">const</span> tz);</div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a7feb4d73c430c3eba420762364530437">scale_Mat4</a>(<a class="code" href="structMat4.html">Mat4</a> *<span class="keyword">const</span> output, <span class="keywordtype">float</span> <span class="keyword">const</span> sx, <span class="keywordtype">float</span> <span class="keyword">const</span> sy,</div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;                <span class="keywordtype">float</span> <span class="keyword">const</span> sz);</div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;</div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#ae047884a59652a5e32b90f555c521c76">copy_Mat4</a>(<a class="code" href="structMat4.html">Mat4</a> *<span class="keyword">const</span> output, <a class="code" href="structMat4.html">Mat4</a> <span class="keyword">const</span> *<span class="keyword">const</span> input);</div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;</div><div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a07a5d933b90b3c5929a3a2a8e37405ba">rotate_Mat4</a>(<a class="code" href="structMat4.html">Mat4</a> *<span class="keyword">const</span> output, <span class="keywordtype">float</span> <span class="keyword">const</span> u, <span class="keywordtype">float</span> <span class="keyword">const</span> v,</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;                 <span class="keywordtype">float</span> <span class="keyword">const</span> w, <span class="keywordtype">float</span> <span class="keyword">const</span> angle);</div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;</div><div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#af2abaae108c4a9bfb7c97e96e0b929be">transpose_Mat4</a>(<a class="code" href="structMat4.html">Mat4</a> *<span class="keyword">const</span> output, <a class="code" href="structMat4.html">Mat4</a> <span class="keyword">const</span> *<span class="keyword">const</span> input);</div><div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;</div><div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a0fc538e9cc74cb89e12dfb6434fb53fd">invert_Mat4</a>(<a class="code" href="structMat4.html">Mat4</a> *<span class="keyword">const</span> output, <a class="code" href="structMat4.html">Mat4</a> <span class="keyword">const</span> *<span class="keyword">const</span> input);</div><div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;</div><div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#afc587139f108be1542c7252e733cb106">construct2DLine</a>(<a class="code" href="structVec3.html">Vec3</a> *<span class="keyword">const</span> line, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> a,</div><div class="line"><a name="l00526"></a><span class="lineno">  526</span>&#160;                     <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> b);</div><div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160;</div><div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;<span class="keywordtype">float</span> <a class="code" href="linearAlgebra_8h.html#ad4ecb8c395a729c3bac403a4f430d3cd">distanceTo2DLine</a>(<a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> line, <a class="code" href="structVec2.html">Vec2</a> <span class="keyword">const</span> *<span class="keyword">const</span> vertex);</div><div class="line"><a name="l00538"></a><span class="lineno">  538</span>&#160;</div><div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160;<span class="keywordtype">void</span> <a class="code" href="linearAlgebra_8h.html#a99d9fc7339bdd41ad0224926a11b4b2b">reflect</a>(<a class="code" href="structVec3.html">Vec3</a> *<span class="keyword">const</span> output, <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> incident,</div><div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160;             <a class="code" href="structVec3.html">Vec3</a> <span class="keyword">const</span> *<span class="keyword">const</span> normal);</div><div class="line"><a name="l00548"></a><span class="lineno">  548</span>&#160;</div><div class="line"><a name="l00549"></a><span class="lineno">  549</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div><div class="line"><a name="l00550"></a><span class="lineno">  550</span>&#160;}</div><div class="line"><a name="l00551"></a><span class="lineno">  551</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="structVec2_html_a9261a5afe6b8369034a4a2157ab6b242"><div class="ttname"><a href="structVec2.html#a9261a5afe6b8369034a4a2157ab6b242">Vec2::data</a></div><div class="ttdeci">float data[2]</div><div class="ttdoc">components of vector </div><div class="ttdef"><b>Definition:</b> linearAlgebra.h:22</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a4c64ae6faf0fd46a33d75789168d7f9e"><div class="ttname"><a href="linearAlgebra_8h.html#a4c64ae6faf0fd46a33d75789168d7f9e">sub_Vec2</a></div><div class="ttdeci">void sub_Vec2(Vec2 *const output, Vec2 const *const a, Vec2 const *const b)</div><div class="ttdoc">This function subtracts two vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:190</div></div>
<div class="ttc" id="linearAlgebra_8h_html_ae2b536efaebb3d1c2377ee9ed17a59ee"><div class="ttname"><a href="linearAlgebra_8h.html#ae2b536efaebb3d1c2377ee9ed17a59ee">copy_Vec4</a></div><div class="ttdeci">void copy_Vec4(Vec4 *const target, Vec4 const *const source)</div><div class="ttdoc">This function copies one vector to another. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:66</div></div>
<div class="ttc" id="linearAlgebra_8h_html_ac2909e84e7ff2328f4022195c670f098"><div class="ttname"><a href="linearAlgebra_8h.html#ac2909e84e7ff2328f4022195c670f098">multiply_Mat4_Vec4</a></div><div class="ttdeci">void multiply_Mat4_Vec4(Vec4 *const output, Mat4 const *const left, Vec4 const *const right)</div><div class="ttdoc">This function multiplies mat4 and vec4 producing vec4. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:331</div></div>
<div class="ttc" id="linearAlgebra_8h_html_aa6574ab0f21fd2161a67abef60544177"><div class="ttname"><a href="linearAlgebra_8h.html#aa6574ab0f21fd2161a67abef60544177">copy_Vec3Float_To_Vec4</a></div><div class="ttdeci">void copy_Vec3Float_To_Vec4(Vec4 *const target, Vec3 const *const part0, float const part1)</div><div class="ttdoc">This function copies vec3 and float to larger vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:90</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a4b41c4aa935f692847c98caf969f4274"><div class="ttname"><a href="linearAlgebra_8h.html#a4b41c4aa935f692847c98caf969f4274">copy_Vec2</a></div><div class="ttdeci">void copy_Vec2(Vec2 *const target, Vec2 const *const source)</div><div class="ttdoc">This function copies one vector to another. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:54</div></div>
<div class="ttc" id="linearAlgebra_8h_html_ad4d638794632fe961f6e5113905e34e1"><div class="ttname"><a href="linearAlgebra_8h.html#ad4d638794632fe961f6e5113905e34e1">sub_Vec3</a></div><div class="ttdeci">void sub_Vec3(Vec3 *const output, Vec3 const *const a, Vec3 const *const b)</div><div class="ttdoc">This function subtracts two vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:197</div></div>
<div class="ttc" id="linearAlgebra_8h_html_aef887725c2f4d11256731400b232a1bf"><div class="ttname"><a href="linearAlgebra_8h.html#aef887725c2f4d11256731400b232a1bf">normalize_Vec2</a></div><div class="ttdeci">void normalize_Vec2(Vec2 *const output, Vec2 const *const input)</div><div class="ttdoc">This function computes normalized vec2. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:298</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a68a9da6c0c100b70184cd882ace57195"><div class="ttname"><a href="linearAlgebra_8h.html#a68a9da6c0c100b70184cd882ace57195">init_Vec4</a></div><div class="ttdeci">void init_Vec4(Vec4 *const target, float const x, float const y, float const z, float const w)</div><div class="ttdoc">This function initializes vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:45</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a0a2303f1ff51da7b5b5391118c21c082"><div class="ttname"><a href="linearAlgebra_8h.html#a0a2303f1ff51da7b5b5391118c21c082">mix_Vec4</a></div><div class="ttdeci">void mix_Vec4(Vec4 *const output, Vec4 const *const a, Vec4 const *const b, float const t)</div><div class="ttdoc">This function linearly mix two vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:229</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a04beb577fb3eb16b699b38c255d8a1c6"><div class="ttname"><a href="linearAlgebra_8h.html#a04beb577fb3eb16b699b38c255d8a1c6">copy_Vec2Vec2_To_Vec4</a></div><div class="ttdeci">void copy_Vec2Vec2_To_Vec4(Vec4 *const target, Vec2 const *const part0, Vec2 const *const part1)</div><div class="ttdoc">This function copies two vec2 to larger vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:110</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a29413d309c1692fac4d63a4fc080903c"><div class="ttname"><a href="linearAlgebra_8h.html#a29413d309c1692fac4d63a4fc080903c">normalize_Vec3</a></div><div class="ttdeci">void normalize_Vec3(Vec3 *const output, Vec3 const *const input)</div><div class="ttdoc">This function computes normalized vec3. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:307</div></div>
<div class="ttc" id="linearAlgebra_8h_html_ae047884a59652a5e32b90f555c521c76"><div class="ttname"><a href="linearAlgebra_8h.html#ae047884a59652a5e32b90f555c521c76">copy_Mat4</a></div><div class="ttdeci">void copy_Mat4(Mat4 *const output, Mat4 const *const input)</div><div class="ttdoc">This function copies mat4 to another mat4. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:394</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a7feb4d73c430c3eba420762364530437"><div class="ttname"><a href="linearAlgebra_8h.html#a7feb4d73c430c3eba420762364530437">scale_Mat4</a></div><div class="ttdeci">void scale_Mat4(Mat4 *const output, float const sx, float const sy, float const sz)</div><div class="ttdoc">This function initializes matrix to scale matrix. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:364</div></div>
<div class="ttc" id="linearAlgebra_8h_html_aff57f5f65e1600067a40687ceea23874"><div class="ttname"><a href="linearAlgebra_8h.html#aff57f5f65e1600067a40687ceea23874">multiply_Vec2_Float</a></div><div class="ttdeci">void multiply_Vec2_Float(Vec2 *const output, Vec2 const *const left, float const constant)</div><div class="ttdoc">This function multiplies vec2 and float. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:262</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a898abc01a7905b120121d45afaba6635"><div class="ttname"><a href="linearAlgebra_8h.html#a898abc01a7905b120121d45afaba6635">init_Vec3</a></div><div class="ttdeci">void init_Vec3(Vec3 *const target, float const x, float const y, float const z)</div><div class="ttdoc">This function initializes vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:37</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a1e6a2affc4b7825a83ce3237c24dc6ce"><div class="ttname"><a href="linearAlgebra_8h.html#a1e6a2affc4b7825a83ce3237c24dc6ce">add_Vec3</a></div><div class="ttdeci">void add_Vec3(Vec3 *const output, Vec3 const *const a, Vec3 const *const b)</div><div class="ttdoc">This function adds two vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:176</div></div>
<div class="ttc" id="linearAlgebra_8h_html_aa007b2ebb3ea356de37ab0d0fa920df7"><div class="ttname"><a href="linearAlgebra_8h.html#aa007b2ebb3ea356de37ab0d0fa920df7">copy_FloatFloatVec2_To_Vec4</a></div><div class="ttdeci">void copy_FloatFloatVec2_To_Vec4(Vec4 *const target, float const part0, float const part1, Vec2 const *const part2)</div><div class="ttdoc">This function copies two floats and vec2 to larger vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:131</div></div>
<div class="ttc" id="linearAlgebra_8h_html_ac534ff8c157e83446ca974ab14b93a5d"><div class="ttname"><a href="linearAlgebra_8h.html#ac534ff8c157e83446ca974ab14b93a5d">copy_Vec2Float_ToVec3</a></div><div class="ttdeci">void copy_Vec2Float_ToVec3(Vec4 *const target, Vec2 const *const part0, float const part1)</div><div class="ttdoc">This function copies vec2 and float to larger vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:151</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a0b0e854e25bc6e5d1438feca06b090d7"><div class="ttname"><a href="linearAlgebra_8h.html#a0b0e854e25bc6e5d1438feca06b090d7">mix_Vec2</a></div><div class="ttdeci">void mix_Vec2(Vec2 *const output, Vec2 const *const a, Vec2 const *const b, float const t)</div><div class="ttdoc">This function linearly mix two vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:211</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a0fc538e9cc74cb89e12dfb6434fb53fd"><div class="ttname"><a href="linearAlgebra_8h.html#a0fc538e9cc74cb89e12dfb6434fb53fd">invert_Mat4</a></div><div class="ttdeci">void invert_Mat4(Mat4 *const output, Mat4 const *const input)</div><div class="ttdoc">This function inverts mat4. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:412</div></div>
<div class="ttc" id="structVec3_html"><div class="ttname"><a href="structVec3.html">Vec3</a></div><div class="ttdoc">This struct represents column 3D vector of 32-bt floats. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.h:28</div></div>
<div class="ttc" id="linearAlgebra_8h_html_ab6dcfc6d07f8a2a3d14935cbf3bbfa07"><div class="ttname"><a href="linearAlgebra_8h.html#ab6dcfc6d07f8a2a3d14935cbf3bbfa07">add_Vec2</a></div><div class="ttdeci">void add_Vec2(Vec2 *const output, Vec2 const *const a, Vec2 const *const b)</div><div class="ttdoc">This function adds two vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:169</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a5831ca0dbb0d418b2abc78df14dc1e17"><div class="ttname"><a href="linearAlgebra_8h.html#a5831ca0dbb0d418b2abc78df14dc1e17">zero_Vec3</a></div><div class="ttdeci">void zero_Vec3(Vec3 *const target)</div><div class="ttdoc">This function sets vector to zero vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:21</div></div>
<div class="ttc" id="linearAlgebra_8h_html_ae21bc90966c71e70db9ee62e6d34f58b"><div class="ttname"><a href="linearAlgebra_8h.html#ae21bc90966c71e70db9ee62e6d34f58b">zero_Vec4</a></div><div class="ttdeci">void zero_Vec4(Vec4 *const target)</div><div class="ttdoc">This function sets vector to zero vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:26</div></div>
<div class="ttc" id="structVec2_html"><div class="ttname"><a href="structVec2.html">Vec2</a></div><div class="ttdoc">This struct represents column 2D vector of 32-bit floats. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.h:21</div></div>
<div class="ttc" id="linearAlgebra_8h_html_aa91dd68aad82e3c0c6b605f44079b00d"><div class="ttname"><a href="linearAlgebra_8h.html#aa91dd68aad82e3c0c6b605f44079b00d">length_Vec4</a></div><div class="ttdeci">float length_Vec4(Vec4 const *const vec)</div><div class="ttdoc">This function computes length of vec4. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:293</div></div>
<div class="ttc" id="linearAlgebra_8h_html_afc587139f108be1542c7252e733cb106"><div class="ttname"><a href="linearAlgebra_8h.html#afc587139f108be1542c7252e733cb106">construct2DLine</a></div><div class="ttdeci">void construct2DLine(Vec3 *const line, Vec2 const *const a, Vec2 const *const b)</div><div class="ttdoc">This function constructs 2D line. The line normal is oriented towards triangle, if the triangle edge ...</div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:457</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a07a5d933b90b3c5929a3a2a8e37405ba"><div class="ttname"><a href="linearAlgebra_8h.html#a07a5d933b90b3c5929a3a2a8e37405ba">rotate_Mat4</a></div><div class="ttdeci">void rotate_Mat4(Mat4 *const output, float const u, float const v, float const w, float const angle)</div><div class="ttdoc">This function initializes matrix to rotation matrix. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:373</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a4ea2f3b452065b47f0068eb9b4cc4ca9"><div class="ttname"><a href="linearAlgebra_8h.html#a4ea2f3b452065b47f0068eb9b4cc4ca9">translate_Mat4</a></div><div class="ttdeci">void translate_Mat4(Mat4 *const output, float const tx, float const ty, float const tz)</div><div class="ttdoc">This function initializes matrix to translate matrix. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:355</div></div>
<div class="ttc" id="linearAlgebra_8h_html_ab34a9fd703888343eb0a7e2b27961fb3"><div class="ttname"><a href="linearAlgebra_8h.html#ab34a9fd703888343eb0a7e2b27961fb3">zero_Vec2</a></div><div class="ttdeci">void zero_Vec2(Vec2 *const target)</div><div class="ttdoc">This function sets vector to zero vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:16</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a6d4b5718ff844e740c5263bddecb6a59"><div class="ttname"><a href="linearAlgebra_8h.html#a6d4b5718ff844e740c5263bddecb6a59">mix_Vec3</a></div><div class="ttdeci">void mix_Vec3(Vec3 *const output, Vec3 const *const a, Vec3 const *const b, float const t)</div><div class="ttdoc">This function linearly mix two vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:220</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a7ada27d45ccfc6522aed3eae2ed8285d"><div class="ttname"><a href="linearAlgebra_8h.html#a7ada27d45ccfc6522aed3eae2ed8285d">copy_Vec3_To_Vec2</a></div><div class="ttdeci">void copy_Vec3_To_Vec2(Vec2 *const target, Vec3 const *const source)</div><div class="ttdoc">This function copies larger vector to smaller vector. This function omits components that are out of ...</div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:84</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a99d9fc7339bdd41ad0224926a11b4b2b"><div class="ttname"><a href="linearAlgebra_8h.html#a99d9fc7339bdd41ad0224926a11b4b2b">reflect</a></div><div class="ttdeci">void reflect(Vec3 *const output, Vec3 const *const incident, Vec3 const *const normal)</div><div class="ttdoc">This function reflect incident vector using normal vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:479</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a67ce5bc16a11e536343b57c65f92e956"><div class="ttname"><a href="linearAlgebra_8h.html#a67ce5bc16a11e536343b57c65f92e956">copy_Vec4_To_Vec3</a></div><div class="ttdeci">void copy_Vec4_To_Vec3(Vec3 *const target, Vec4 const *const source)</div><div class="ttdoc">This function copies larger vector to smaller vector. This function omits components that are out of ...</div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:78</div></div>
<div class="ttc" id="structVec4_html"><div class="ttname"><a href="structVec4.html">Vec4</a></div><div class="ttdoc">This struct represents column 4D vector of 32-bit floats. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.h:35</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a39cec24734072d94f327b9ee5c1b3681"><div class="ttname"><a href="linearAlgebra_8h.html#a39cec24734072d94f327b9ee5c1b3681">length_Vec3</a></div><div class="ttdeci">float length_Vec3(Vec3 const *const vec)</div><div class="ttdoc">This function computes length of vec3. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:288</div></div>
<div class="ttc" id="linearAlgebra_8h_html_aa24f5597fea40cea6a1f928efd5f78f8"><div class="ttname"><a href="linearAlgebra_8h.html#aa24f5597fea40cea6a1f928efd5f78f8">sub_Vec4</a></div><div class="ttdeci">void sub_Vec4(Vec4 *const output, Vec4 const *const a, Vec4 const *const b)</div><div class="ttdoc">This function subtracts two vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:204</div></div>
<div class="ttc" id="student_2fwd_8h_html"><div class="ttname"><a href="student_2fwd_8h.html">fwd.h</a></div><div class="ttdoc">This file contains forward declarations and constants. </div></div>
<div class="ttc" id="linearAlgebra_8h_html_a2edd6c868ced671c9680036a35c2a928"><div class="ttname"><a href="linearAlgebra_8h.html#a2edd6c868ced671c9680036a35c2a928">dot_Vec3</a></div><div class="ttdeci">float dot_Vec3(Vec3 const *const left, Vec3 const *const right)</div><div class="ttdoc">This function computes dot product of two vec3 vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:246</div></div>
<div class="ttc" id="linearAlgebra_8h_html_abf949f1e249e3d1c231ee72e65a9696a"><div class="ttname"><a href="linearAlgebra_8h.html#abf949f1e249e3d1c231ee72e65a9696a">copy_FloatVec3_To_Vec4</a></div><div class="ttdeci">void copy_FloatVec3_To_Vec4(Vec4 *const target, float const part0, Vec3 const *const part1)</div><div class="ttdoc">This function copies float and vec3 to larger vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:141</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a8333ef95a3ea4503121bd0f8ec2e5a93"><div class="ttname"><a href="linearAlgebra_8h.html#a8333ef95a3ea4503121bd0f8ec2e5a93">normalize_Vec4</a></div><div class="ttdeci">void normalize_Vec4(Vec4 *const output, Vec4 const *const input)</div><div class="ttdoc">This function computes normalized vec4. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:316</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a216e370049726fef73d41d74a7fdbb0a"><div class="ttname"><a href="linearAlgebra_8h.html#a216e370049726fef73d41d74a7fdbb0a">add_Vec4</a></div><div class="ttdeci">void add_Vec4(Vec4 *const output, Vec4 const *const a, Vec4 const *const b)</div><div class="ttdoc">This function adds two vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:183</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a92095b5e7b71fdf9862d93defbd05c48"><div class="ttname"><a href="linearAlgebra_8h.html#a92095b5e7b71fdf9862d93defbd05c48">copy_Vec3</a></div><div class="ttdeci">void copy_Vec3(Vec3 *const target, Vec3 const *const source)</div><div class="ttdoc">This function copies one vector to another. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:60</div></div>
<div class="ttc" id="linearAlgebra_8h_html_ab490710375f17e4c453720b4f3a6de1f"><div class="ttname"><a href="linearAlgebra_8h.html#ab490710375f17e4c453720b4f3a6de1f">multiply_Mat4_Mat4</a></div><div class="ttdeci">void multiply_Mat4_Mat4(Mat4 *const output, Mat4 const *const left, Mat4 const *const right)</div><div class="ttdoc">This function multiplies mat4 and mat4 producing mat4. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:344</div></div>
<div class="ttc" id="linearAlgebra_8h_html_af2abaae108c4a9bfb7c97e96e0b929be"><div class="ttname"><a href="linearAlgebra_8h.html#af2abaae108c4a9bfb7c97e96e0b929be">transpose_Mat4</a></div><div class="ttdeci">void transpose_Mat4(Mat4 *const output, Mat4 const *const input)</div><div class="ttdoc">This function transposes mat4. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:403</div></div>
<div class="ttc" id="linearAlgebra_8h_html_ab16d533e580c6a3e2a640bdf17bbc9d1"><div class="ttname"><a href="linearAlgebra_8h.html#ab16d533e580c6a3e2a640bdf17bbc9d1">copy_FloatVec2Float_To_Vec4</a></div><div class="ttdeci">void copy_FloatVec2Float_To_Vec4(Vec4 *const target, float const part0, Vec2 const *const part1, float const part2)</div><div class="ttdoc">This function copies two floats and vec2 to larger vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:121</div></div>
<div class="ttc" id="linearAlgebra_8h_html_ad4ecb8c395a729c3bac403a4f430d3cd"><div class="ttname"><a href="linearAlgebra_8h.html#ad4ecb8c395a729c3bac403a4f430d3cd">distanceTo2DLine</a></div><div class="ttdeci">float distanceTo2DLine(Vec3 const *const line, Vec2 const *const vertex)</div><div class="ttdoc">This function computes distance to 2D line. The normal of the line is assumed to be to normalized...</div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:472</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a41de0162479b762fb9636c4ca2ec67bc"><div class="ttname"><a href="linearAlgebra_8h.html#a41de0162479b762fb9636c4ca2ec67bc">dot_Vec4</a></div><div class="ttdeci">float dot_Vec4(Vec4 const *const left, Vec4 const *const right)</div><div class="ttdoc">This function computes dot product of two vec4 vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:254</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a03f118667e1d4b11494bcb17ea2053cd"><div class="ttname"><a href="linearAlgebra_8h.html#a03f118667e1d4b11494bcb17ea2053cd">multiply_Vec4_Float</a></div><div class="ttdeci">void multiply_Vec4_Float(Vec4 *const output, Vec4 const *const left, float const constant)</div><div class="ttdoc">This function multiplies vec4 and float. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:276</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a46906f31d88c1e39620f3dc2bdcc1647"><div class="ttname"><a href="linearAlgebra_8h.html#a46906f31d88c1e39620f3dc2bdcc1647">copy_Vec4_To_Vec2</a></div><div class="ttdeci">void copy_Vec4_To_Vec2(Vec2 *const target, Vec4 const *const source)</div><div class="ttdoc">This function copies larger vector to smaller vector. This function omits components that are out of ...</div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:72</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a7c4638820b8913fe877927aaf4c84491"><div class="ttname"><a href="linearAlgebra_8h.html#a7c4638820b8913fe877927aaf4c84491">copy_FloatVec2_ToVec3</a></div><div class="ttdeci">void copy_FloatVec2_ToVec3(Vec4 *const target, float const part0, Vec2 const *const part1)</div><div class="ttdoc">This function copies float and vec2 to larger vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:160</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a4d63505aa04912e56e7718227477339d"><div class="ttname"><a href="linearAlgebra_8h.html#a4d63505aa04912e56e7718227477339d">length_Vec2</a></div><div class="ttdeci">float length_Vec2(Vec2 const *const vec)</div><div class="ttdoc">This function computes length of vec2. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:283</div></div>
<div class="ttc" id="linearAlgebra_8h_html_abc0563608a098756d6628f85c5805bf6"><div class="ttname"><a href="linearAlgebra_8h.html#abc0563608a098756d6628f85c5805bf6">identity_Mat4</a></div><div class="ttdeci">void identity_Mat4(Mat4 *const output)</div><div class="ttdoc">This function initializes matrix to identity. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:325</div></div>
<div class="ttc" id="linearAlgebra_8h_html_acecead10da9d132574e7f7de5b28158b"><div class="ttname"><a href="linearAlgebra_8h.html#acecead10da9d132574e7f7de5b28158b">copy_Vec2FloatFloat_To_Vec4</a></div><div class="ttdeci">void copy_Vec2FloatFloat_To_Vec4(Vec4 *const target, Vec2 const *const part0, float const part1, float const part2)</div><div class="ttdoc">This function copies vec2 and two floats to larger vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:100</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a84d6cf8f129f96393c19af1cd4da6475"><div class="ttname"><a href="linearAlgebra_8h.html#a84d6cf8f129f96393c19af1cd4da6475">dot_Vec2</a></div><div class="ttdeci">float dot_Vec2(Vec2 const *const left, Vec2 const *const right)</div><div class="ttdoc">This functions computes dot product of two vec2 vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:238</div></div>
<div class="ttc" id="structMat4_html"><div class="ttname"><a href="structMat4.html">Mat4</a></div><div class="ttdoc">This struct represents 4x4 matrix - it is represented by 4 column vectors. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.h:43</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a700c57a419d937e84616e877039ea500"><div class="ttname"><a href="linearAlgebra_8h.html#a700c57a419d937e84616e877039ea500">multiply_Vec3_Float</a></div><div class="ttdeci">void multiply_Vec3_Float(Vec3 *const output, Vec3 const *const left, float const constant)</div><div class="ttdoc">This function multiplies vec3 and float. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:269</div></div>
<div class="ttc" id="linearAlgebra_8h_html_a2d4ebe1f775e16099a296626a20e944b"><div class="ttname"><a href="linearAlgebra_8h.html#a2d4ebe1f775e16099a296626a20e944b">init_Vec2</a></div><div class="ttdeci">void init_Vec2(Vec2 *const target, float const x, float const y)</div><div class="ttdoc">This function initializes vector. </div><div class="ttdef"><b>Definition:</b> linearAlgebra.c:31</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Apr 23 2019 13:21:21 for Izg project by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
